﻿Imports System.IO
Imports System.Runtime.InteropServices

Public Class FrmExplorer

    'kleines Beispiel für einen Ordner- und Datei-Browser (Explorer)
    'hier können Ordner bzw. Dateien angezeigt, geöffnet und gelöscht werden
    'und kann, je nach Bedarf, noch stark erweitert werden

    'für evtl. auftretende Schäden wird nicht gehaftet!!!

    'dieses Projekt kann frei verwendet werden!

    '**************************************************************************
    'Dieser Source stammt von http://www.vb-fun.de und kann frei
    'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
    'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
    'Quellenangabe veröffentlicht werden (siehe hierzu auch die
    'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
    'Für eventuelle Schäden wird nicht gehaftet.

    'Proportionen des Original beibehanlten
    'Übergeben werden muss das Bitmap und entweder W oder H
    Private Function Thumbnail_Proportional(ByVal b As Bitmap, ByVal w As Integer, ByVal h As Integer) As Bitmap
        If w = 0 And h = 0 Then
            w = b.Size.Width
            h = b.Size.Height
        ElseIf w = 0 Then
            w = CInt(h / b.Size.Height * b.Size.Width)
        ElseIf h = 0 Then
            h = CInt(w / b.Size.Width * b.Size.Height)
        End If
        Return CType(b.GetThumbnailImage(w, h, Nothing, IntPtr.Zero), Bitmap)
    End Function
    '**************************************************************************

    Dim lvImgabelist As New ImageList
    Private StartDir As String  'z.B. C:\ oder D:\ usw.
    Dim aktOrdner As String     'z.B. C:\Dokumente und Einstellungen\Username\Eigene Dateien

    Private Structure SHFILEINFO

        Public hIcon As IntPtr ' : icon 
        Public iIcon As Integer ' : icondex
        Public dwAttributes As Integer ' : SFGAO_ flags
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=260)> _
        Public szDisplayName As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=80)> _
        Public szTypeName As String
    End Structure

    Private Declare Auto Function SHGetFileInfo Lib "shell32.dll" _
    (ByVal pszPath As String, _
    ByVal dwFileAttributes As Integer, _
    ByRef psfi As SHFILEINFO, _
    ByVal cbFileInfo As Integer, _
    ByVal uFlags As Integer) As IntPtr
    Private Const SHGFI_ICON As Integer = &H100
    Private Const SHGFI_SMALLICON As Integer = &H1
    Private Const SHGFI_LARGEICON As Integer = &H0    ' Large icon

#Region "Bildschirm einfrieren und wieder auftauen"

    'einfrieren und auftauen des Bildschirms
    Public Declare Function LockWindowUpdate Lib "user32" _
            (ByVal hwndLock As Int32) As Int32

    Public Declare Function GetDesktopWindow Lib "user32" _
            () As Int32

    Public Sub Freeze()
        'Fenster einfrieren
        LockWindowUpdate(GetDesktopWindow)
    End Sub

    Public Sub Defrost()
        'Fenster wieder normal anzeigen
        LockWindowUpdate(0&)
    End Sub

#End Region

    Sub AddImages(ByVal strName As String, ByVal idx As Integer, Optional ByVal bLargeIcon As Boolean = False)
        Dim shInfo As New SHFILEINFO
        Dim hIcon As IntPtr = SHGetFileInfo(strName, 0, shInfo, Marshal.SizeOf(shInfo), SHGFI_ICON Or SHGFI_SMALLICON)
        lvImgabelist.Images.Add(strName, Drawing.Icon.FromHandle(shInfo.hIcon))
        ListViewFiles.Items(idx).ImageIndex = idx
    End Sub

    Private Sub FrmExplorer_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        With ListViewFiles
            .View = View.Details
            .SmallImageList = lvImgabelist

            Call fillDrive()
            aktOrdner = My.Computer.FileSystem.SpecialDirectories.MyDocuments()

            Call CallRecursive(Me.trvVerzeichnis, aktOrdner)

            GetData(aktOrdner)

        End With
    End Sub

#Region "TreeView und Sub´s bzw. Funktionen"
    Public Function IsDriveReady(ByVal sDrive As String) As Boolean
        'aus dem vbarchiv
        ' Prüft, ob das angegebene Laufwerk existiert und 
        ' ob darauf zugegriffen werden kann
        Try
            Dim oDrive As New System.IO.DriveInfo(sDrive)
            Return oDrive.IsReady
        Catch ex As Exception
            Return False
        End Try
    End Function

    Private Sub fillDrive()
        With Me
            'Tree-View füllen
            Dim Drive As String
            Dim tn As TreeNode
            Dim DriveZähler As Integer
            DriveZähler = 0
            'für die Ermittlung des Typs
            Dim iType As Integer
            iType = 0
            Dim allDrives() As DriveInfo = DriveInfo.GetDrives()
            Dim strType As String

            Dim Verzeichnis As IO.DirectoryInfo
            With ListViewFiles
                .View = View.Details
            End With
            .trvVerzeichnis.Nodes.Clear()

            ' Wiedergabe der logischen Laufwerke des PCs
            For Each Drive In Environment.GetLogicalDrives
                If IsDriveReady(Drive) Then
                    DriveZähler = DriveZähler + 1

                    strType = allDrives(iType).DriveType.ToString

                    ' Laufwerk wird als Rootknoten dem Treeview hinzugefügt
                    tn = trvVerzeichnis.Nodes.Add(Drive, Drive, strType, strType)

                    ' In der Tag-Eigenschaft kann man alle möglichen Daten 
                    ' und Objekte speichern. Hier wäre z.B beim Erstellen
                    ' eines Explorers der Pfad von Interesse, um z.B im 
                    ' ListView die Daten anzuzeigen. Wir brauchen hier aber 
                    ' die Pfadangabe für das spätere Hinzufügen von 
                    ' Unterverzeichnisse im Treeview 
                    tn.Tag = Drive
                    If DriveZähler = 1 Then
                        aktOrdner = tn.Tag
                    End If

                    ' Falls das Laufwerk Unterverzeichnisse besitzt, 
                    ' soll das "+" Zeichen eingeblendet werden
                    Try
                        For Each Verzeichnis In New  _
                          IO.DirectoryInfo(Drive).GetDirectories

                            ' Hinzufügen eines Dummyknotens
                            tn.Nodes.Add(Verzeichnis.Name)

                            ' Es reicht ein ermitteltes Unterverzeichnis 
                            ' aus, um das  "+" zu erzeugen"
                            Exit For
                        Next
                    Catch
                    End Try
                End If
                iType = iType + 1
            Next
        End With
    End Sub

    Private Sub Recursive(ByVal n As TreeNode)
        Try

            With Me
                Dim aNode As TreeNode
                Dim x As Integer
                Dim b As Boolean
                b = False
                For Each aNode In n.Nodes
                    'die vorhandenen Einträge der Combobox durchsuchen
                    For x = 1 To .cboOrdner.Items.Count - 1
                        'auf Übereinstimmung prüfen
                        If StrConv(.cboOrdner.Items.Item(x), VbStrConv.Lowercase) = _
                        StrConv(aNode.Text, VbStrConv.Lowercase) Then
                            b = True
                            With .trvVerzeichnis
                                .SelectedNode = aNode
                                .Select()
                            End With

                            aNode.Expand()
                            Recursive(aNode)
                            Exit For
                        End If
                    Next
                    If b = True Then
                        Exit For
                    End If
                Next
            End With

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    'TreeView mit einem beliebigen Pfad öffnen
    Public Sub CallRecursive(ByVal aTreeView As TreeView, ByVal searchstr As String)
        Dim n As TreeNode
        Dim arr As Integer

        If My.Computer.FileSystem.DirectoryExists(searchstr) Then

            With Me.cboOrdner
                .Items.Clear()
                '************************************************************
                'die Pfadteile (Ordner) einlesen
                '************************************************************
                'den Text inhalt der Variable zuweisen
                Dim strArrayOrdner As String = searchstr
                'Array initialisieren und füllen
                Dim ArrayOrdner() As String = Split(strArrayOrdner, "\")
                'Variable für die entsprechende Wertaufnahme
                Dim OZähler As Integer = -1
                For i As Integer = 0 To ArrayOrdner.Length - 1
                    If ArrayOrdner(i) <> "" Then
                        OZähler += 1
                        ArrayOrdner(OZähler) = ArrayOrdner(i)
                    End If
                Next

                'Datenfeld ist nun mit den Werten gefüllt
                ReDim Preserve ArrayOrdner(OZähler)

                For arr = 0 To UBound(ArrayOrdner)
                    .Items.Add(ArrayOrdner(arr))
                Next
                '************************************************************

                aTreeView.BeginUpdate()
                aTreeView.CollapseAll()
                Try
                    For Each n In aTreeView.Nodes
                        '1. Node (das entsprechende Laufwerk)
                        If StrConv(.Items.Item(0).ToString & "\", VbStrConv.Lowercase) = _
                        StrConv(n.Text, VbStrConv.Lowercase) Then
                            n.Expand()
                            Recursive(n)
                            Exit For
                        End If
                    Next
                Catch ex As Exception

                End Try
            End With
            aTreeView.EndUpdate()
        End If
    End Sub

    Private Sub trvVerzeichnis_BeforeExpand(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles trvVerzeichnis.BeforeExpand
        ' Bevor der Knoten expandiert, ermitteln wir den 
        ' Knoten. Wir können dann vorab alle Unterverzeichnisse
        ' und deren Unterverzeichnisse (es wird aber nur das 
        ' erste Unterverzeichnis eingelesen) über die Prozedur 
        ' Read_Directory einlesen. Beim anschliessenden Expandieren 
        ' des(Knoten) werden dann bei Vorhandensein von 
        ' Unterverzeichnissen die "+" 'Zeichen angezeigt.

        Dim tn As TreeNode

        tn = e.Node
        Read_Directory(tn)
    End Sub

    Private Sub Read_Directory(ByVal Knoten As TreeNode)
        ' Erstellen eines DirectoryInfo-Objektes, um 
        ' die Unterverzeichnisse einzulesen.
        ' Die benötigte Pfadangabe zum Erzeugen des Objekts 
        ' ermitteln wir aus der Tag-Eigenschaft des Knotens 
        ' (siehe Form1_Load). Wichtig ist, dass der Inhalt 
        ' der Tag-Eigenschaft erst mit der Methode CType in 
        ' den entsprechenden Typ konvertiert werden muss!!
        Dim Verzeichnis As New  _
          IO.DirectoryInfo(CType(Knoten.Tag, String))

        Dim Unterverzeichnis As IO.DirectoryInfo
        Dim Dummyverzeichnis As IO.DirectoryInfo

        Dim tn As TreeNode

        ' Ein Flackern des Treeview soll vermieden werden
        trvVerzeichnis.BeginUpdate()
        'FileImageList.Images.Clear()

        ' Der zuvor erzeugte Dummyknoten wird wieder entfernt, 
        ' da dieser beim Einlesen sonst doppelt vorhanden wäre
        Knoten.Nodes.Clear()

        Try
            Me.Cursor = Cursors.WaitCursor

            For Each Unterverzeichnis In Verzeichnis.GetDirectories
                Dim strUnterverzeichnisAttribute As String = Unterverzeichnis.Attributes.ToString
                If InStr(strUnterverzeichnisAttribute, "Hidden") Or InStr(strUnterverzeichnisAttribute, "System") Then
                    'den entsprechenden Ordner nicht anzeigen
                Else
                    tn = Knoten.Nodes.Add(Unterverzeichnis.Name)
                    tn.Tag = Unterverzeichnis.FullName

                    ' Falls das Unterverzeichnis weitere Unterverzeichnisse 
                    ' besitzt, soll das "+" Zeichen eingeblendet werden
                    Try
                        For Each Dummyverzeichnis In New  _
                          IO.DirectoryInfo(Unterverzeichnis.FullName).GetDirectories

                            ' Hinzufügen eines Dummyknotens
                            tn.Nodes.Add(Verzeichnis.Name)

                            ' Es reicht ein ermitteltes Unterverzeichnis 
                            ' aus, um das  "+" zu erzeugen"
                            Exit For
                        Next
                    Catch
                    End Try
                End If
            Next
        Catch
        End Try

        trvVerzeichnis.EndUpdate()
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub trvVerzeichnis_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles trvVerzeichnis.GotFocus
        With Me
            .tbbtnÖffnen.Enabled = False
            .tbbtnLöschen.Enabled = False
        End With
    End Sub

    Private Sub trvVerzeichnis_NodeMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles trvVerzeichnis.NodeMouseClick

        ' Für die Demo das ListView füllen...
        ' ===================================
        Me.Cursor = Cursors.WaitCursor
        ListViewFiles.BeginUpdate()
        ListViewFiles.Items.Clear()
        Dim SubItemIndex As Integer = 0

        Try
            Dim n As TreeNode = CType(e.Node, TreeNode)
            Dim d As New DirectoryInfo(n.FullPath)

            GetData(d.FullName)

            'den aktuellen Ordner festlegen
            aktOrdner = d.FullName

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        ListViewFiles.EndUpdate()
        Me.Cursor = Cursors.Default
    End Sub
#End Region

#Region "ListView und Sub´s bzw. Funktionen"

    Private Function aktPath(ByVal Ordnername As String) As String
        If Microsoft.VisualBasic.Right(Ordnername, 1) <> "\" Then
            aktPath = Ordnername & "\"
        Else
            aktPath = Ordnername
        End If
    End Function

    Private Function FileNamekürzen(ByVal strFile As String) As String
        If InStr(strFile, "\") Then
            'Dateinamen kürzen für Dateien (C:\...)
            FileNamekürzen = Mid(strFile, InStrRev(strFile, "\") + 1)
        Else
            'bei WebBrowser-Vorschau (WebBrowser1.Url.ToString = "about:blank") und/oder ???
            FileNamekürzen = strFile
        End If
    End Function

    Public Function Umrechnen(ByVal nSize As Double) As String
        'Dieser Source stammt von http://www.activevb.de
        Select Case nSize
            ' Gigabytebereich
            Case Is >= 1024 ^ 3
                nSize = nSize / 1024 ^ 3
                If nSize < 10 Then
                    Umrechnen = Format$(nSize, "0.00 GB")
                ElseIf nSize < 100 Then
                    Umrechnen = Format$(nSize, "0.0 GB")
                Else
                    Umrechnen = Format$(Fix(nSize), "0 GB")
                End If
                ' Megabytebereich
            Case Is >= 1024 ^ 2
                nSize = nSize / 1024 ^ 2
                If nSize < 10 Then
                    Umrechnen = Format$(nSize, "0.00 MB")
                ElseIf nSize < 100 Then
                    Umrechnen = Format$(nSize, "0.0 MB")
                Else
                    Umrechnen = Format$(Fix(nSize), "0 MB")
                End If
                ' Kilobytebereich
            Case Is >= 1024
                nSize = nSize / 1024
                Umrechnen = Format$(nSize, "0.0 KB") ' Bytebereich
            Case Else
                Umrechnen = Format$(nSize, "0") & " Byte"
        End Select

    End Function

    Private Sub GetData(ByVal folder As String)
        Try

            If Not folder Is Nothing Then

                Dim subdir As IO.DirectoryInfo, diFolder As New IO.DirectoryInfo(folder)
                Dim file As IO.FileInfo, SubItemIndex As Integer = 0
                Try

                    lvImgabelist.Images.Clear()
                    Me.lblaktDir.Text = folder
                    aktOrdner = folder
                    StartDir = Microsoft.VisualBasic.Left(folder, 3)

                    PicThumbnail.Visible = False
                    PicThumbnail.Image = Nothing

                    Dim Flength As Long

                    With ListViewFiles
                        .BeginUpdate()

                        .Items.Clear()

                        'Zuerst alle Ordner darstellen, falls vorhanden
                        For Each subdir In diFolder.GetDirectories()
                            Dim strUnterverzeichnisAttribute As String = subdir.Attributes.ToString
                            If InStr(strUnterverzeichnisAttribute, "Hidden") Or InStr(strUnterverzeichnisAttribute, "System") Then
                                'den entsprechenden Ordner nicht anzeigen
                            Else
                                .Items.Add(subdir.Name.ToString)
                                .Items(SubItemIndex).SubItems.Add("Dateiordner")
                                .Items(SubItemIndex).SubItems.Add("")
                                .Items(SubItemIndex).SubItems.Add(subdir.CreationTime.ToString("dd.MM.yy  HH:mm"))
                                .Items(SubItemIndex).SubItems.Add(subdir.LastWriteTime.ToString("dd.MM.yy  HH:mm"))
                                .Items(SubItemIndex).SubItems.Add(subdir.LastAccessTime.ToString("dd.MM.yy  HH:mm"))
                                .Items(SubItemIndex).SubItems.Add(subdir.Attributes.ToString)
                                Call AddImages(subdir.FullName, SubItemIndex)
                                .Items.Item(SubItemIndex).Tag = "Dateiordner"
                                SubItemIndex += 1
                            End If
                        Next

                        'Dann die Dateien 
                        For Each file In diFolder.GetFiles()
                            Dim strFileAttributes As String
                            strFileAttributes = file.Attributes.ToString

                            'auf Attribute prüfen
                            If StrConv(InStr(strFileAttributes, "Hidden"), VbStrConv.Lowercase) _
                            Or StrConv(InStr(strFileAttributes, "System"), VbStrConv.Lowercase) _
                            Or StrConv(InStr(strFileAttributes, "ReadOnly"), VbStrConv.Lowercase) Then
                                'nicht sichtbare, schreibgeschüzte und System Dateien nicht auflisten
                            Else
                                .Items.Add(file.Name.ToString)
                                .Items(SubItemIndex).SubItems.Add(file.Extension.ToString)
                                Flength = file.Length.ToString
                                .Items(SubItemIndex).SubItems.Add(Umrechnen(Flength))
                                .Items(SubItemIndex).SubItems.Add(file.CreationTime.ToString("dd.MM.yy  HH:mm"))
                                .Items(SubItemIndex).SubItems.Add(file.LastWriteTime.ToString("dd.MM.yy  HH:mm"))
                                .Items(SubItemIndex).SubItems.Add(file.LastAccessTime.ToString("dd.MM.yy  HH:mm"))
                                .Items(SubItemIndex).SubItems.Add(file.Attributes.ToString)
                                Call AddImages(file.FullName, SubItemIndex)
                                .Items.Item(SubItemIndex).Tag = "Datei"
                                SubItemIndex += 1
                            End If
                        Next
                        Me.tbbtnDirUp.Enabled = (StrConv(folder.ToString, VbStrConv.Lowercase) <> StrConv(StartDir, VbStrConv.Lowercase))
                        .EndUpdate()

                    End With
                Catch ex As Exception
                    MsgBox(ex.Message, MsgBoxStyle.Exclamation)
                End Try

            End If

        Catch ex As Exception
            'MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub Thumpnailanzeigen(ByVal Filename As String)
        Try

            If Filename <> String.Empty Then
                If My.Computer.FileSystem.FileExists(Filename) Then
                    Try

                        'Normales Bild einlesen
                        Dim b As Bitmap = New Bitmap(Filename)

                        'Thumbnail_Proportional
                        Dim ThumbnailProp As Bitmap = Thumbnail_Proportional(b, 100, 0)
                        PicThumbnail.Visible = True
                        PicThumbnail.Image = ThumbnailProp

                    Catch ex As Exception
                        PicThumbnail.Visible = False
                        PicThumbnail.Image = Nothing
                    End Try
                End If
            End If

        Catch ex As Exception
            PicThumbnail.Visible = False
            PicThumbnail.Image = Nothing
        End Try
    End Sub

    Private Sub Löschen()
        With Me.ListViewFiles
            If .Items.Count > 0 Then

                For i As Integer = 0 To .Items.Count - 1
                    If .Items.Item(i).Selected Then
                        Try

                            Dim strFile As String = aktPath(aktOrdner) & .Items.Item(i).Text.ToString
                            Dim strQuestion As String = ""
                            'prüfen auf Ordner bzw. Datei
                            If .Items.Item(i).Tag = "Dateiordner" Then
                                strQuestion = "Möchtest du den Ordner:" & vbCrLf & vbCrLf _
                                      & FileNamekürzen(strFile) & vbCrLf & vbCrLf & "wirklich löschen?"
                            Else
                                strQuestion = "Möchtest du die Datei:" & vbCrLf & vbCrLf _
                                      & FileNamekürzen(strFile) & vbCrLf & vbCrLf & "wirklich löschen?"
                            End If
                            'prüfen auf Ordner bzw. Datei
                            Dim bDir As Boolean = (.Items.Item(i).Tag = "Dateiordner")

                            If MsgBox(strQuestion, _
                                      MsgBoxStyle.Question + MsgBoxStyle.YesNo, _
                                      .Items.Item(i).Tag & " löschen?") = MsgBoxResult.Yes Then
                                If bDir Then
                                    'Ordner in den Papierkorb verschieben
                                    My.Computer.FileSystem.DeleteDirectory _
                                    (strFile, FileIO.UIOption.OnlyErrorDialogs, FileIO.RecycleOption.SendToRecycleBin, _
                                     FileIO.UICancelOption.ThrowException)
                                Else
                                    'Datei in den Papierkorb verschieben
                                    My.Computer.FileSystem.DeleteFile _
                                    (strFile, FileIO.UIOption.OnlyErrorDialogs, FileIO.RecycleOption.SendToRecycleBin, _
                                     FileIO.UICancelOption.ThrowException)
                                End If
                                'die Dokumentliste entsprechend aktuallisieren
                                With Me.ListViewFiles
                                    .BeginUpdate()
                                    If .Items.Count > 0 Then
                                        For iFile As Integer = .Items.Count - 1 To 0 Step -1
                                            If aktPath(aktOrdner) & .Items.Item(iFile).ToString = strFile Then
                                                .Items.Item(iFile).Remove()
                                                Exit For
                                            End If
                                        Next
                                    End If
                                    .EndUpdate()
                                End With

                            End If

                        Catch ex As Exception
                            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
                        End Try

                        Exit For
                    End If
                Next

                Call Freeze()
                'den aktuellen Inhalt des Projektpfads anzeigen
                .Items.Clear()
                Call CallRecursive(Me.trvVerzeichnis, aktOrdner)
                Call GetData(aktPath(aktOrdner))
                Call Defrost()

            End If
        End With
    End Sub

    Private Sub ListViewFiles_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewFiles.DoubleClick
        Call FileListViewAction()
    End Sub

    Private Sub ListViewFiles_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewFiles.GotFocus
        With Me
            .tbbtnÖffnen.Enabled = True
            .tbbtnLöschen.Enabled = True
        End With
    End Sub

    Private Sub ListViewFiles_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ListViewFiles.KeyUp
        Select Case e.KeyCode
            Case Keys.Return    'Ordner wechseln oder Datei öffnen
                Call FileListViewAction()
            Case Keys.Delete    'Ordner bzw. Datei löschen
                Call Löschen()
        End Select
    End Sub

    Private Sub FileListViewAction()
        With Me.ListViewFiles.Items
            If .Count > 0 Then
                For i As Integer = 0 To .Count - 1
                    If .Item(i).Selected Then
                        If .Item(i).Tag = "Dateiordner" Then
                            Call Freeze()
                            aktOrdner = aktPath(aktOrdner) & .Item(i).Text

                            'entsprechend aktualisieren
                            If My.Computer.FileSystem.DirectoryExists(aktOrdner) Then
                                Call CallRecursive(Me.trvVerzeichnis, aktOrdner)
                                GetData(aktOrdner)
                            Else
                                'Eigene Dateien als Startknoten
                                aktOrdner = My.Computer.FileSystem.SpecialDirectories.MyDocuments.ToString
                                Call CallRecursive(Me.trvVerzeichnis, aktOrdner)
                                GetData(aktOrdner)
                            End If
                            Call Defrost()
                        ElseIf .Item(i).Tag = "Datei" Then

                            'Datei öffnen
                            Call Öffnen(False, aktPath(Me.lblaktDir.Text) & .Item(i).Text)

                        End If
                        Exit For
                    End If
                Next
            End If
        End With
    End Sub

    Private Sub ListViewFiles_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewFiles.SelectedIndexChanged
        Try
            With Me.ListViewFiles
                If .Items.Count > 0 Then
                    For i As Integer = 0 To .Items.Count - 1
                        If .Items.Item(i).Selected Then
                            'löschen von Ordnern und Dateien einschränken
                            Dim FileAttribute As String = StrConv(.Items(i).SubItems(6).Text.ToString, VbStrConv.Lowercase)
                            Me.tbbtnLöschen.Enabled = (InStr(FileAttribute, StrConv("ReadOnly", VbStrConv.Lowercase)) = False)
                            'auf Datei oder Ordner prüfen
                            If .Items.Item(i).Tag = "Datei" Then
                                Dim FileExtention As String = StrConv(.Items(i).SubItems(1).Text.ToString, VbStrConv.Lowercase)
                                Select Case FileExtention
                                    'wenn möglich eine Vorschau anzeigen
                                    Case ".gif", ".jpg", ".jpe", ".jpeg", ".png", ".wmf", ".ico", ".bmp"
                                        Call Thumpnailanzeigen(aktPath(aktOrdner) & .Items.Item(i).Text)
                                    Case Else
                                        Me.PicThumbnail.Image = Nothing
                                        Me.PicThumbnail.Visible = False
                                End Select
                            Else
                                Me.PicThumbnail.Visible = False
                            End If
                        End If
                    Next
                End If
            End With
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

#End Region

#Region "Toolbar und Sub´s"

    Private Sub DirUp()
        'einen Ordner aufwärts

        If StrConv(aktOrdner, VbStrConv.Lowercase) = StrConv(StartDir, VbStrConv.Lowercase) Then Exit Sub
        aktOrdner = Microsoft.VisualBasic.Left(aktOrdner, InStrRev(aktOrdner, "\", Len(aktOrdner) - 1))

        Call Freeze()
        Call CallRecursive(Me.trvVerzeichnis, aktOrdner)
        Call GetData(aktOrdner)
        Call Defrost()

    End Sub

    Private Sub Öffnen(ByVal bDirectory As Boolean, ByVal Filename As String)
        Try

            If bDirectory Then
                'Ordner öffnen
                Dim di As New DirectoryInfo(Filename)
                Process.Start(di.ToString)
            Else
                'Datei öffnen
                Dim fi As New FileInfo(Filename)
                Process.Start(fi.ToString)
            End If

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub tbbtnÖffnen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnÖffnen.Click
        Try
            With Me.ListViewFiles.Items
                If .Count > 0 Then
                    For i As Integer = 0 To .Count - 1
                        If .Item(i).Selected Then

                            Dim sFile As String = aktPath(Me.lblaktDir.Text) & .Item(i).Text
                            Dim bDir As Boolean = .Item(i).Tag = "Dateiordner"
                            Call Öffnen(bDir, sFile)

                            Exit For

                        End If
                    Next
                End If
            End With
        Catch exp As Exception
            MsgBox(exp.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub tbbtnLöschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnLöschen.Click
        Call Löschen()
    End Sub

    Private Sub tbbtnDirUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnDirUp.Click
        Call DirUp()
    End Sub

    Private Sub tbbtnBeenden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnBeenden.Click
        Me.Close()
    End Sub
#End Region

End Class
